import sys
#sys.path.append('/c/Users/lippert/Projects/limix/python/utils/')
sys.path.append('c:\\Users\\lippert\\Projects\\limix\\python\\utils')

from fastlmm import *

aricpath = 'c:\Users\lippert\Projects\ARIC' 

#/c/Users//Projects/wtccc/tiny/

phen = 'corrected'
phen = 'orig'

if 0:#600kSNPs
    pheno_file = os.path.join(aricpath, 'whitemale.pheno.'+phen)
    snps_file = os.path.join(aricpath, 'whitemale')
    out_dir = os.path.join('.\out_aric\outbig', phen)
else:#60k SNPs
    pheno_file = os.path.join(aricpath, 'whitemale.pheno.'+phen)
    snps_file = os.path.join(aricpath, 'fewsnps')
    snps_file = os.path.join(snps_file, 'fewsnps_0.1.maf5')
    out_dir = os.path.join('.\out_aric\outsmall', phen)

if 1:
    opt =[
        '--out',
        out_dir,
        '--bfile',
        snps_file,
        '--bfilesim',
        snps_file,
        '--pheno',
        pheno_file
        ]


def load_phenofile():
    pheno_file = os.path.join(aricpath, 'phenotypes.txt')
    data = sp.loadtxt(pheno_file,dtype = 'str', delimiter ='\t')
    header = data[0,:]
    vals = data[1::,:]
    vals =vals[vals[:,-1]!='',:]

    col = 8; name = 'height'; #height
    #col  = 13; name = 'bmi' #bmi
    #col = 14; name = 'weight' #weight
    #col = 15; name = 'Qti' #Qti
    #col = 16; name = 'vWF' #vWF

    lnphenotype = sp.zeros(vals[:,9].shape)
    phenotype = sp.zeros(vals[:,col].shape)          #in cm
    gender = vals[:,6]                          # M F
    age = sp.array(vals[:,7],dtype = 'float')   #years
                    
    race = vals[:,5]                            # B W



    for i in xrange(phenotype.shape[0]):
        if len(vals[i,col])>0:
            phenotype[i] = float(vals[i,col])
            lnphenotype[i] = sp.log(phenotype[i])
        else:
            #pdb.set_trace()
            phenotype[i] = sp.nan
            lnphenotype[i] = sp.nan

    i_OK = lnphenotype==lnphenotype        

    i_W = race =='W'
    i_B = race =='B'
    i_M = gender =='M'
    i_F = gender =='F'
    
    i_WM = i_OK.copy()
    i_WF = i_OK.copy()
    i_BM = i_OK.copy()
    i_BF = i_OK.copy()
    for i in xrange(i_M.shape[0]):
        if i_M[i]:
            i_WF[i] = False
            i_BF[i] = False
        else:
            i_WM[i] = False
            i_BM[i] = False
            
        if i_W[i]:
            i_BM[i] = False
            i_BF[i] = False
        else:
            i_WM[i] = False
            i_WF[i] = False
    
    pdb.set_trace()
    pheno_WM = sp.zeros((i_WM.sum(),3),dtype = 'S20')
    pheno_WM[:,0]= vals[i_WM][:,2]
    pheno_WM[:,1]= vals[i_WM][:,3]
    pheno_WM[:,2] = phenotype[i_WM]
    
    pheno_out_file = os.path.join(aricpath,'whitemale.pheno.orig')
    np.savetxt(pheno_out_file,pheno_WM,'%s',delimiter = '\t')
    ind={
        'all':i_OK[i_OK],
        'W':i_W[i_OK],
        'B':i_B[i_OK],
        'M':i_M[i_OK],
        'F':i_F[i_OK],
        'WM':i_WM[i_OK],
        'WF':i_WF[i_OK],
        'BM':i_BM[i_OK],
        'BF':i_BF[i_OK]
        }
    gen=sp.zeros(i_OK.shape)
    gen[i_M] = 1
    gen[i_F] = -1
    rac=sp.zeros(i_OK.shape)
    rac[i_W] = 1
    rac[i_B] = -1
    
    
    
    return vals[:,0:4][i_OK],gen[i_OK],age[i_OK],rac[i_OK],phenotype[i_OK],ind,name
    

def thin_individuals(fraction = '0.1'):
    pheno = np.loadtxt(pheno_file, dtype = str, delimiter = '\t')
    aricpathout = os.path.join(aricpath,'fewSNPs')
    if not os.path.exists(aricpathout):
        os.makedirs(aricpathout)
    out_f = 'fewsnps_%s.maf5' %(fraction)
    out_file = os.path.join(aricpathout, out_f)
    command = '%s --bfile %s --make-bed --out %s --thin %s --maf 0.05' %(plink_path, snps_file, out_file, fraction)
    s.check_call(command, shell = True)
    pdb.set_trace()
    
def plot_height(sg ='W'):
    index,gen,age,rac,phenotype,group,name = load_phenofile()
    ages = sp.unique(age[group[sg]])
    meanPhen = sp.zeros(ages.shape)
    stdPhen = sp.zeros(ages.shape)
    
    #sliding window average
    for i in xrange(ages.shape[0]):
        diff = (((age[group[sg]]-ages[i])/2.5)**2.0)
        weight = sp.exp(-diff)*1.0
        meanPhen[i]=sp.sum(phenotype[group[sg]]*weight)/weight.sum()
        #stdPhen[i] = sp.std(phenotype[group[sg]][i_age])
    plt.interactive(1)
    plt.figure()
    titles = '%s individuals - %s vs. age' % (sg,name)
    plt.title(titles)
    #pdb.set_trace()
    namel = ('%s' %name)
    plt.plot(age[group[sg]]+0.01*sp.randn(phenotype[group[sg]].shape[0]),(phenotype[group[sg]])+0.01*sp.randn(phenotype[group[sg]].shape[0]),'.b')
    plt.plot(ages,meanPhen,'r')
    plt.xlabel('age')
    plt.ylabel(namel)
    #plt.plot(ages,meanPhen+2*stdPhen,'g')
    #plt.plot(ages,meanPhen-2*stdPhen,'g')
   # pdb.set_trace()
    
    if (sg =='W' or sg == 'B' or sg == 'all'):
        #compare gender
        plt.interactive(1)
        plt.figure()
        iM = gen[group[sg]]==1
        iF = gen[group[sg]]==-1
        meanM = sp.mean(phenotype[group[sg]][iM])
        meanF = sp.mean(phenotype[group[sg]][iF])
        #pdb.set_trace()
        plt.plot(gen[group[sg]]+0.2*sp.randn(phenotype[group[sg]].shape[0]),phenotype[group[sg]],'.b')
        plt.plot([1,-1],[meanM,meanF],'r')
        titles = '%s individuals - %s vs. gender' % (sg,name)
        plt.title(titles)
        plt.xlabel('gender')
        plt.xticks([-1,1],['female','male'])
        plt.ylabel(namel)
        #pdb.set_trace()
    
    if (sg =='M' or sg == 'F' or sg == 'all'):
        #compare races
        plt.interactive(1)
        plt.figure()
        titles = '%s individuals - %s vs. race' % (sg,name)
        plt.title(titles)
        plt.xlabel('race')
        plt.xticks([-1,1],['black','white'])
        plt.ylabel(namel)
        iW = rac[group[sg]]==1
        iB = rac[group[sg]]==-1
        meanW = sp.mean(phenotype[group[sg]][iW])
        meanB = sp.mean(phenotype[group[sg]][iB])
        #pdb.set_trace()
        plt.plot(rac[group[sg]]+0.2*sp.randn(phenotype[group[sg]].shape[0]),phenotype[group[sg]],'.b')
        plt.plot([1,-1],[meanW,meanB],'r')
    pdb.set_trace()
    
if __name__ == '__main__':
    (options, args) = get_options(opt)
    
    if 'plot' in sys.argv:
        plot_height(sg = 'W')#women smaller
        #plot_height(sg = 'B')
        #plot_height(sg = 'M')
        plot_height(sg = 'F') #black larger than white =>find ancestry informative SNPs
        #plot_height(sg = 'all')
        plot_height(sg = 'WM') #smaller with age

    if 'lmm' in sys.argv:
        command_LMM = run_fastlmm(pheno_file = options.pheno_file,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim,tfile_sim= options.tfile_sim, out_dir=options.out_dir, covariates = options.covariates, excl_dist = options.excl_dist, excl_pos = options.excl_pos, chr_only = options.chr_only, testing = False, quiet = False, N=None,refit_delta = False)
    
    if 'linreg' in sys.argv:
        command_linreg = run_linreg(pheno_file = options.pheno_file, file_test=options.file_test, bfile_test = options.bfile_test, tfile_test = options.tfile_test, out_dir=options.out_dir, covariates = options.covariates, chr_only = options.chr_only, testing = False, quiet = False)
    #index,gen,age,rac,phenotype,group = load_phenofile()#12mins with all SNPs
#    reduceSamplesize()
    plt.interactive(1)
    #pvals = load_pvals('./out_aric/outbig/corrected/results_linreg.txt',False, True) ; qqplot(pvals)
    #pvals2 = load_pvals('./out_aric/outbig/orig/results_linreg.txt',False, True) ; qqplot(pvals2)
    #pvals = load_pvals('./out_aric/outsmall/corrected/results_linreg.txt',True, True) ; qqplot(pvals[:,0])
    #pvals2 = load_pvals('./out_aric/outsmall/orig/results_linreg.txt',True, True) ; qqplot(pvals2[:,0])
