import sys
import cPickle
import os
#add limix path
#limix
import platform
import scipy.stats as st


#use is this as I am running code on linux and MAC.
#I have two compiled instances of limix around..
sys.path.append('./../lib/limix/python')
sys.path.append('./../lib')
if len(platform.mac_ver()[0])>0:
    sys.path.append('./../lib/limix/build_mac/src/interfaces/python')
else:
    sys.path.append('./../lib/limix/build_linux/src/interfaces/python')

import data
from plot import *
from variance_components import *
    
#import main limix module
import limix
from utils.util import *
import utils.fdr as fdr
#import preprocessing utils
import utils.preprocess as preprocess

#pythong plotting and numerical tools
import scipy as SP
import pylab as PL
import h5py
import pdb


if __name__ == '__main__':
 
    from pyplot import *
    PL.ion()
    
    pheno_names = ['1_LD']
 
    cache_file = './demo_cacheFT.pickle'
    #1. load GWAS data
    if not os.path.exists(cache_file) or 'recalc' in sys.argv:
        #1. load data
        data = data.load_arab107(pheno_names)
        cPickle.dump(data,open(cache_file,'wb'),-1)
    else:
        data= cPickle.load(open(cache_file,'rb'))
    globals().update(data)
    #Pheno = SP.log(Pheno - Pheno.min() + 1)

    #1. estimate heritability of a few phenotypes and plot
    f = h5py.File('./../data/arab107/Nordborg_data.h5py','r')
    geno_ID    = SP.array(f['geno/meta'][1::,4],dtype='int')
    pheno_ID = f['pheno/ecotype_id'][:]
    chrom = f['geno/chrom'][:]
    #select subset of genotypes relevant in at least one phenotype
    Irel = SP.array([SP.nonzero(geno_ID==id)[0][0] for id in pheno_ID])
    

    X = f['geno/x'][:].T
    X = SP.array(X[Irel],dtype='float')
    X -= X.mean(axis=0)
    X /= X.std(axis=0)
    K = 1.0/(X.shape[1]) * SP.dot(X,X.T)
    Y  = f['pheno/Y'][:]
    phenotype_names = f['pheno/phenotype_names'][:]

    #create covariances per chromosome
    uchrom = SP.unique(chrom)
    Kchrom = []
    for ic in uchrom:
        II = (chrom==ic)
        _X = X[:,II]
        _K = 1.0/(_X.shape[1]) * SP.dot(_X,_X.T)
        Kchrom.append(_K)

    if 0:
        #Plot covaraince matrix for the first 20 lines
        PL.figure()
        imagesc(K[0:20][:,0:20])
        PL.xlabel('Samples')
        PL.ylabel('Samples')
        PL.savefig('./Kgeno.pdf')

    if 1:
        #overall genetic heritability for all 107 phenotypes
        herG = SP.zeros([Y.shape[1]])
        #per chromosome heritability
        herC = SP.zeros([Y.shape[1],len(uchrom)])
        
        #instantiate variance component fitting
        vt = limix.CMultiTraitVQTL()

        for ip in xrange(Y.shape[1]):
            print ip
            _Y = Y[:,ip][:,SP.newaxis]
            Iok = ~SP.isnan(_Y[:,0])
            _Y = _Y[Iok]
            _K = K[Iok,:][:,Iok]
            herG[ip] = vt.estimateHeritability(_Y,_K)
            #per chromosome heritabiltiy
            for ic in xrange(len(uchrom)):
                _K = Kchrom[ic][Iok,:][:,Iok]
                herC[ip,ic] = vt.estimateHeritability(_Y,_K)
            pass

        #1. plot overal genetic heritabiltiy histogram
        PL.figure()
        PL.hist(herG,10,normed=True)
        PL.xlabel('Heritability')
        PL.ylabel('Density')
        PL.savefig('./heritability_atwell.pdf')

        #2. plot per chromosome estimated heritability
        PL.figure(figsize=[7,10])
        Is = herG.argsort()
        imagesc(herC[Is,:],colormap=PL.cm.hot)
        PL.colorbar()
        PL.xticks(SP.arange(herC.shape[1]),SP.arange(herC.shape[1])+1)
        PL.xlabel('Chromosome')
        PL.yticks(SP.arange(herC.shape[0])[::5],SP.arange(herC.shape[0])[::5]+1)
        PL.ylabel('Phenotype ID')
        PL.savefig('./heritability_atwell_chrom.pdf')
        
