import scipy as SP
import limix
import utils.preprocess as preprocess


def simple_lmm(snps,pheno,K,covs=None):
    lm = limix.CLMM()
    lm.setK(preprocess.scale_K(K))
    lm.setSNPs(snps)
    lm.setPheno(pheno)
    if covs is None:
        covs = SP.ones([snps.shape[0],1])
    lm.setCovs(covs)
    lm.process()
    return lm
