import sys
import cPickle
import os
#add limix path
#limix
import platform
import scipy.stats as st


#use is this as I am running code on linux and MAC.
#I have two compiled instances of limix around..
sys.path.append('./../lib/limix/python')
sys.path.append('./../lib')
if len(platform.mac_ver()[0])>0:
    sys.path.append('./../lib/limix/build_mac/src/interfaces/python')
else:
    sys.path.append('./../lib/limix/build_linux/src/interfaces/python')

import data
from plot import *
from qtl import *
    
#import main limix module
import limix
from utils.util import *
from variance_components import *
import utils.fdr as fdr
#import preprocessing utils
import utils.preprocess as preprocess

#pythong plotting and numerical tools
import scipy as SP
import pylab as PL
import h5py
import pdb


    
def getXfixed(TraitID):
    Xfixed = SP.zeros([TraitID.shape[0],Ntrait])
    ii = 0
    for it in SP.unique(TraitID):
        Xfixed[:,ii] = 1.0*(TraitID==it)[:,0]
        ii+=1
    return Xfixed




if __name__ == '__main__':
 
    from pyplot import *
    PL.ion()
    
    pheno_names = ['1_LD']
 
    cache_file = './demo_cacheFT.pickle'
    #1. load GWAS data
    if not os.path.exists(cache_file) or 'recalc' in sys.argv:
        #1. load data
        data = data.load_arab107(pheno_names)
        cPickle.dump(data,open(cache_file,'wb'),-1)
    else:
        data= cPickle.load(open(cache_file,'rb'))
    globals().update(data)

        #Pheno = SP.log(Pheno - Pheno.min() + 1)
        
    if 1:
        print "1. carrying out standard GWAs"
        #1. standard GWAs on each trait
        PL.figure(1,figsize=[12,6])        
        lm = simple_lmm(X,Pheno,Kpop)
        pv = lm.getPv().ravel()
        qv = fdr.qvalues(pv)
        manhattanplot(pv,chrom,pos,qv=qv)
        PL.savefig('./1_LD.pdf')
        PL.savefig('./1_LD.png')

    if 1:
        print "3. Varaince component analysis using a sliding window approach with conditioning on the background"
        #window size
        WS = [10E6,2E6,0.5E6]
        RV = []
        for iw in xrange(len(WS)):
            ws = WS[iw]
            sz = 2*ws
            RV.append(var_comp_SW(X,Pheno,pos,cum_pos,ws=ws,sz=sz,background=True))
        #plot
        sbp = 100*(len(WS)+1)+11
        if 0:
            PL.figure(figsize=[12,10])
            #manhattan plot of mixed model
            PL.subplot(sbp)
            manhattanplot(pv,chrom,pos,qv=qv)
            #go through cycles
            for iw in xrange(len(WS)):
                PL.subplot(sbp+iw+1)
                bar_plot_SW(RV[iw])
        PL.figure(figsize=[12,10])
        PL.subplot(sbp)
        manhattanplot(pv,chrom,pos,qv=qv)
        PL.xlabel('')
        for iw in xrange(len(WS)):
            PL.subplot(sbp+iw+1)
            bar_plot_SW(RV[iw],field='var_block')
            PL.ylim([0,1])
            PL.ylabel('Variance explained')
        PL.xlabel('Genomic position')
        PL.savefig('./sliding_window_test_background.pdf')
        PL.savefig('./sliding_window_test_background.png')
        pass

        
