import sys
#sys.path.append('/c/Users/lippert/Projects/limix/python/utils/')
sys.path.append('c:\\Users\\lippert\\Projects\\limix\\python\\utils')

from fastlmm import *

datapath = 'c:\Users\lippert\Projects\wtccc'#/c/Users//Projects/wtccc

if 0:#3.5k individuals
    wtcccpath = os.path.join(datapath,'small') 
    pheno_file = os.path.join(wtcccpath , 'ibd-nbs.plink.txt')
    snps_file = os.path.join(wtcccpath , 'plink')
    out_path = '.\out_wtccc\small'

if 0:#thin out individuals
    wtcccpath = os.path.join(datapath,'tiny' )
    pheno_file = os.path.join(wtcccpath , 'tiny.pheno.txt')
    snps_file = os.path.join(wtcccpath , 'tiny.maf5.snps')
    out_path = '.\out_wtccc\tiny'

if 1:#thin out SNPs
    wtcccpath = os.path.join(datapath,'fewSNPs' )
    pheno_file = os.path.join(wtcccpath , 'ibd-nbs.plink.txt')
    snps_file = os.path.join(wtcccpath , 'fewsnps_0.2.maf5')
    out_path = ('.\out_wtccc\\fewSNPs')

if 1:    
    opt =[
        '--out',
        out_path,
        '--bfile',
        snps_file,
        '--bfilesim',
        snps_file,
        '--pheno',
        pheno_file,
        '--exclude_distance',
        2.0
        ]
if 1:
    opt =[
        '--out',
        out_path,
        '--bfile',
        snps_file,
        '--bfilesim',
        snps_file,
        '--pheno',
        pheno_file,
        '--exclude_distance',
        '2.0'
        ]
    
def thin_individuals(fraction = '0.2'):
    pheno = np.loadtxt(pheno_file, dtype = str, delimiter = '\t')
    wtcccpathout = os.path.join(datapath,'fewSNPs')
    if not os.path.exists(wtcccpathout):
        os.makedirs(wtcccpathout)
    out_f = 'fewsnps_%s.maf5' %(fraction)
    out_file = os.path.join(wtcccpathout, out_f)
    command = '%s --bfile %s --make-bed --out %s --thin %s --maf 0.05' %(plink_path, snps_file, out_file, fraction)
    s.check_call(command, shell = True)
    pdb.set_trace()



if __name__ == '__main__':
    (options, args) = get_options(opt)
    #thin_individuals()

    if 'linreg' in sys.argv:
        command_linreg = run_linreg(pheno_file = options.pheno_file, file_test=options.file_test, bfile_test = options.bfile_test, tfile_test = options.tfile_test, out_dir=options.out_dir, covariates = options.covariates, chr_only = options.chr_only, testing = False, quiet = False)

    if 'full' in sys.argv:
        outfull = os.path.join(options.out_dir,'full')
        command_LMM = run_fastlmm(pheno_file = options.pheno_file,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim,tfile_sim= options.tfile_sim, out_dir=outfull, covariates = options.covariates, excl_dist = None, excl_pos = options.excl_pos, chr_only = options.chr_only, testing = False, quiet = False, N=None,refit_delta = False)#started 11.15am
    
    if 'exclude' in sys.argv:
        outexclude = os.path.join(options.out_dir,'exclude')
        command_LMM = run_fastlmm(pheno_file = options.pheno_file,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim,tfile_sim= options.tfile_sim, out_dir=outexclude, covariates = options.covariates, excl_dist = None, excl_pos = options.excl_pos, chr_only = options.chr_only, testing = False, quiet = False, N=None,refit_delta = False)#started 11.15am
    
    if 'select' in sys.argv:#fastlmm select
        linreg_out = os.path.join(out_path, 'results_linreg.txt')

        Nsnps0,lambdas0 = run_select_topN(pheno_file= options.pheno_file, linreg_out=linreg_out,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim, tfile_sim = options.tfile_sim, out_dir=options.out_dir, covariates = options.covariates, excl_dist = options.excl_dist, excl_pos = options.excl_pos, chr_only = options.chr_only, quiet = False, refit_delta = False, command=None, Nmin=0, Nmax=200, increment=10)

        Nsnps1,lambdas1 = run_select_topN(pheno_file= options.pheno_file, linreg_out=linreg_out,file_test=options.file_test,bfile_test = options.bfile_test,tfile_test = options.tfile_test,bfile_sim = options.bfile_sim,file_sim = options.file_sim, tfile_sim = options.tfile_sim, out_dir=options.out_dir, covariates = options.covariates, excl_dist = options.excl_dist, excl_pos = options.excl_pos, chr_only = options.chr_only, quiet = False, refit_delta = False, command=None, Nmin=80, Nmax=110, increment=3)
        nsnps = np.hstack([Nsnps0,Nsnps1])
        lambdas = np.hstack([lambdas0,lambdas1])
    
        order = nsnps.argsort()
        lambdas = lambdas[order]
        nsnps = nsnps[order]
        poly = np.polyfit(nsnps,lambdas,3)
        X = sp.arange(nsnps.min(),nsnps.max(),0.1)
        plt.interactive()
        plt.plot(nanps,lambdas)
        plt.plot(X,np.polyval(poly,X))
    
